#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell.h"
#include "rof.h"

using namespace std;

// ܓxEoxEox30b̒EőlEԒlEŏlE[̃Obhǂ߂B
// 30b(1km)f̊iqTCYłBlatitude(ܓx)̃ObhTCY͖111.2kmœłB
// longitude(ox)̃TCY͈ܓxɂĈقȂ̂ŌvZKvB

// vZł͍łk()̍s0sƍlĂB(20120211)

void Cell::setLocation (
	int rowStep, // row counter
	int colStep, // column counter
	int nRow, // number of row for the study area
	int nCol, //number of column for the study area
	float SWlat, // South west corner of latitude
	float SWlon, // South west corner of longitude
	int topoScale // Topography scale. 1 means 3 second.
)
{
	// setting latitude in 'sec' unit
	latitude  = (float)(SWlat*3600 + 3*topoScale*(nRow-rowStep-1) + 1.5*topoScale);	//3: gridcell size in second.

	// setting longitude in 'sec' unit
	longitude = (float)(SWlon*3600 + 3*topoScale*colStep + 1.5*topoScale);

	// setting length (km) for 1 degree in longitude direction
	longitudinalLength = (float)92.6886*topoScale*(float)cos(latitude/3600.0/180.0*3.14);	//92.6886: gridcell size at equator in meter (3s ~ 92.6886 m).

}

/* ̃Obh܂܂ROFZn_̓f[^猈߂ */
void Cell::setPointROFCell(ROF* fROF, int num)
{
	double x=(double)longitude/3600.0;
	double y=(double)latitude/3600.0;
	double distance;
	double distancei;


	//ł́CfROFObh߂ɕבւD
	//fROF̓|C^Ȃ̂ŁCCfbNXւēւs 2014/7/13
	int *temp;
	temp = new int[num];
	for(int i=0; i<num; i++){
		temp[i]=i;
	}

	int buf;
	for(int i=0; i<num; i++){
		
		distancei = sqrt(pow(x-(double)fROF[temp[i]].longitude, 2.0)+pow(y-(double)fROF[temp[i]].latitude, 2.0));
		for(int ii=i+1; ii<num; ii++){
			distance = sqrt(pow(x-(double)fROF[temp[ii]].longitude, 2.0)+pow(y-(double)fROF[temp[ii]].latitude, 2.0));
			if(distance < distancei){
				//ԂւD
				buf = temp[i];
				temp[i]=temp[ii];
				temp[ii]=buf;

				distancei = distance;
			}
		}
	}

	//בւԂɃIuWFNgD
	ROFCell = new class ROF*[num];
	for(int i=0; i<num; i++){
		ROFCell[i] = &fROF[temp[i]];
	}
}

