#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "rof.h"
#include "cell.h"

using namespace std;

int main()
{
	cout << "Reading parameters for runoff simulation." << endl;
	ifstream finParam("./param-event.dat");
	if(!finParam){
		cout << "param-event.dat cannot open." << endl;
	}

	// vZ̈ simulation range
	cout << "1) Reading parameters for study area." << endl;

	int wCol, wRow, wTopoScale;
	float wSWLON, wSWLAT;

	finParam >> wTopoScale;
	cout << "  Topography scale : " << wTopoScale << endl;

	const int TopoScale = wTopoScale;

	finParam >> wCol; 
	finParam >> wRow; 
	cout << "  Number of col : " << wCol << "  Number of row : " << wRow << endl;

	finParam >> wSWLON; 
	finParam >> wSWLAT;
	cout << " Sorth West corner Longitude (degree) : " << wSWLON 
		 << " Latitude (deg) : " << wSWLAT << endl;

	const int Col = wCol;     // column number of study area
	const int Row = wRow;     // row number of study area
	const float SWLON = wSWLON; // South west corner of longitude (degree)
	const float SWLAT = wSWLAT; // South west corner of latiitude (degree)

	// ̓f[^̎ type of input data
	cout << "2) Reading parameters for input data." << endl;

	// Obhx[X̓̓f[^̈ input data range
	// n_f[^̒n_
	int wROFnum;
	finParam >> wROFnum;
	cout << "  Number of points of point rain data : " << wROFnum << endl;
	const int ROFnum = wROFnum;// 2013/8/25 Tanaka

	// vZ simulation term
	cout << "3) Reading parameters for simuration duration." << endl;
	int wNdays;
	finParam >> wNdays;
	cout << "  Simulation duration (days) : " << wNdays << endl;

	const int Ndays = wNdays; // Simulation duration (days)

	// ԕ@̑I interporation style
	cout << "4) Reading parameters for interporation style." << endl;
	cout << "   1: Interporate the nearest and valid point (if the nearest point has no data, find the second nearest point)" << endl;
	cout << "   2: Interporate the nearest point (even if it has no data)" << endl;
	int wStyle;
	finParam >> wStyle;
	cout << "  Interporation style : " << wStyle << endl;

	const int Style = wStyle; // Interporation style

	// o͌`̑I output data format
	cout << "5) Reading parameters for output data format." << endl;
	cout << "   1: Text format" << endl;
	cout << "   2: Binary" << endl;
	int wOutType;
	finParam >> wOutType;
	cout << "  Output data format : " << wOutType << endl;

	const int OutType = wOutType; // Interporation style

	finParam.close();
	//--------------------- end parameter reading ------------------------------------------------


	//ϐ̒` dif-variables
	int iday, ihour, dt;
	int n, k;
	//errno_t error;
	
	char FileName[256];
	float Nodata = -9999;

	// Memory assignment for grid cell of simulation
	class Cell** cellObject; 
	cellObject = new class Cell*[Row];
	for(int i=0; i<Row; i++){
		cellObject[i] = new class Cell[Col];
	}

	// Memory assignment for data cell of input data
	/*--- ̓f[^IuWFNgɏ ---*/
	//eIuWFNgɈܓxEox
	class ROF* PointrofObject;
	PointrofObject = new class ROF[ROFnum];

	int pointNum;
	float ROFlat, ROFlon;

	//sprintf_s(FileName, 256, "./input/pointData.dat");
	sprintf(FileName, "./input/pointData.dat");
	cout << "  Read " << FileName << endl;
	ifstream finP(FileName);
	if(!finP){
		cout << FileName << " cannot open." << endl;
		exit(1);
	}
	for(int point=0; point < ROFnum; point++){
		finP >> pointNum >> ROFlat >> ROFlon;
		PointrofObject[point].setPointInformation(&ROFlat, &ROFlon, pointNum, Ndays);
	}

	/* ovZZ̈ʒuL */
	for(int i=Row-1; i>=0; i--) {
		for(int j=0; j<Col; j++) {
			cellObject[i][j].setLocation(i, j, Row, Col, SWLAT, SWLON, TopoScale);
		}
	}

	/* CellɑΉROFCellݒ肷 */
	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++){
			cellObject[i][j].setPointROFCell(PointrofObject, ROFnum);
		}
	}


	// --- ̓f[^̓ǂݍ read input data ---
	int year, month, day, hour;
	char PointROFfilename[256];
	int pointRead = -1;
	for(int point=0; point < ROFnum; point++){
		//sprintf_s(FileName, 256, "./input/rain%d.dat, point+1");
		sprintf(FileName, "./input/rain%d.dat", PointrofObject[point].id);
		cout << "Read " << FileName << endl;
		ifstream finR(FileName);
		if(!finR){
			//IɈ߂ɁC
			//t@CȂꍇ͌xoNodataD
			cout << "Point file No." << point << " cannot open.\n";
			cout << "Longitude" << PointrofObject[point].longitude << "  Latitude : " << PointrofObject[point].latitude << endl;
			exit(1);
			
			for(int iday=0; iday < Ndays; iday++){
				for(int ihour=0; ihour<24; ihour++){
					PointrofObject[point].value[iday][ihour] = Nodata;
				}
			}
			continue;
		
		}
		pointRead = point;
		for(int iday=0; iday < Ndays; iday++){
			for(int ihour=0; ihour<24; ihour++){
				finR >> year >> month >> day >> hour >> PointrofObject[point].value[iday][ihour];
			}
		}
		finR.close();
	}



	/*-------------- Output distributed rainfall data assigned to each grid from point rain data-------------- */
	float r;

	if(OutType == 1){//Text data
		ofstream FileRainfall; // Hourly data
		//sprintf_s(FileName, 256, "./output/rain.dat");
		sprintf(FileName, "./output/rain.dat");
		cout << "Write " << FileName << endl;
		FileRainfall.open(FileName, ios::out);
	
		ofstream FileThiessen; // for debug
		//sprintf_s(FileName, 256, "./output/thiessen.dat");
		sprintf(FileName, "./output/thiessen.dat");
		cout << "Write " << FileName << endl;
		FileThiessen.open(FileName, ios::out);
		
		// added to write proper year/month/day/hour by Tanaka T. 2022/6/2
		sprintf(FileName, "./input/rain%d.dat", PointrofObject[pointRead].id);
		ifstream finR(FileName);
		if(!finR){
			exit(1);
		}
		
		for(iday=0; iday < Ndays; iday++){
			for (ihour=0; ihour < 24; ihour++) {
				
				double val;
				finR >> year >> month >> day >> hour >> val;
				
				FileRainfall << year << " " << month << " " << day << " " << hour << " " << Col << " " << Row << endl;
				FileThiessen << year << " " << month << " " << day << " " << hour << " " << Col << " " << Row << endl;
				for(int m=0; m<Row; m++){
					for(n=0; n<Col; n++){
						if(Style == 1){
							r=-9999;
							for(int ir=0; ir<ROFnum; ir++){
								if(cellObject[m][n].ROFCell[ir]->value[iday][ihour] > -1.0){
									r = cellObject[m][n].ROFCell[ir]->value[iday][ihour];
									FileRainfall << r << " ";
	
									FileThiessen << setw(4) << cellObject[m][n].ROFCell[ir]->id << " ";
	
									break;
								}
							}
							if(r==-9999){//1f[^Ȃꍇ͌D
								FileRainfall << Nodata << " ";
								FileThiessen << setw(4) << Nodata << " ";
							}
						}
						else if(Style == 2){
							r = cellObject[m][n].ROFCell[0]->value[iday][ihour];
							FileRainfall << r << " ";
	
							FileThiessen << setw(4) << cellObject[m][n].ROFCell[0]->id << " ";
						}//̕ԕ@ǉꍇ͂ɒǉ
						else{
							cout << "Invalid style is selected." << endl;
							exit(1);
						}
					}
					FileRainfall << endl;
					FileThiessen << endl;
				}
			}
		}
		FileRainfall.close();
		FileThiessen.close();
		finR.close();
	}
	else{//Binary data
		ofstream FileRainfallBinary; // Hourly data
		//sprintf_s(FileName, 256, "./output/rain.bin");
		sprintf(FileName, "./output/rain.bin");
		cout << "Write " << FileName << endl;
		FileRainfallBinary.open(FileName, ios::out | ios::binary);
		for(iday=0; iday < Ndays; iday++){
			for (ihour=0; ihour < 24; ihour++) {
				for(int m=Row-1; m >=0; m--){ // latitude direction from South for Grads format
					for(n=0; n<Col; n++){     // longitude direction from West
						if(Style == 1){
							r=-9999;
							for(int ir=0; ir<ROFnum; ir++){
								if(cellObject[m][n].ROFCell[ir]->value[iday][ihour] > -1.0){
									r = cellObject[m][n].ROFCell[ir]->value[iday][ihour];
									FileRainfallBinary.write((char*)&r, sizeof(float));
									break;
								}
							}
							if(r==-9999){//1f[^Ȃꍇ͌D
								FileRainfallBinary.write((char*)&Nodata, sizeof(float));
							}
						}
						else if(Style == 2){
							r = cellObject[m][n].ROFCell[0]->value[iday][ihour];
							FileRainfallBinary.write((char*)&r, sizeof(float));
						}//̕ԕ@ǉꍇ͂ɒǉ
						else{
							cout << "Invalid style is selected." << endl;
							exit(1);
						}
					}
				}
			}
		}
		FileRainfallBinary.close();
	}


	for(int i=0; i<Row; i++){
		delete[] cellObject[i];
	}
	delete[] cellObject;

	delete[] PointrofObject;//2013/8/25 Tanaka

	return 0;
}

